// Copyright (C) 1999-2009
// Smithsonian Astrophysical Observatory, Cambridge, MA, USA
// For conditions of distribution and use, see copyright notice in "copyright"

#ifndef __coord_h__
#define __coord_h__

#include <string.h>

#include <iostream>
#include <sstream>
#include <iomanip>
using namespace std;

enum InternalSystem {WINDOW, CANVAS, WIDGET, USER, REF, DATA, PANNER};
enum CoordSystem {IMAGE, PHYSICAL, AMPLIFIER, DETECTOR, WCS,
		  WCSA, WCSB, WCSC, WCSD, WCSE, WCSF, WCSG, WCSH, WCSI,
		  WCSJ, WCSK, WCSL, WCSM, WCSN, WCSO, WCSP, WCSQ, WCSR,
		  WCSS, WCST, WCSU, WCSV, WCSW, WCSX, WCSY, WCSZ, WCS0};
enum SkyFrame {FK4, FK5, ICRS, GALACTIC, ECLIPTIC, NATIVEWCS};
enum SkyFormat {DEGREES, SEXAGESIMAL, HMS, ARCMIN, ARCSEC};
enum Precision {DEFAULT, FIXED, SCIENTIFIC, INTEGER};
enum AngleFormat {DEGREE, RADIAN};

enum Orientation {NORMAL, XX, YY, XY};

// SkyFrame SkyFormat strings

extern char *coordSystemStr_[];
extern char *skyFrameStr_[];
extern char *skyFormatStr_[];

void listCoordSystem(ostream&, CoordSystem, SkyFrame, int, int);
void listDistSystem(ostream&, CoordSystem, SkyFormat, int);
void listProsCoordSystem(ostream&, CoordSystem, SkyFrame);

void strToCoordSystem(const char*, CoordSystem*, SkyFrame*);
void strToSkyFormat(const char*, SkyFormat*);
void strToAngleFormat(const char*, AngleFormat*);
void strToDistSystem(const char*, CoordSystem*, SkyFormat*);

#endif
