// Copyright (C) 1999-2009
// Smithsonian Astrophysical Observatory, Cambridge, MA, USA
// For conditions of distribution and use, see copyright notice in "copyright"

#ifndef __text_h__
#define __text_h__

#include "marker.h"

class Text : public Marker {
 private:
  int rotate;

 private:
  void renderX(Drawable, const Matrix&, RenderMode);
  void renderPS(int);
#ifdef _MACOSX
  void renderMACOSX();
#endif
#ifdef _WIN32
  void renderWIN32();
#endif

 public:
  Text(const Text&);
  Text(FrameBase* p, const Vector& ctr,
       double a, int r,
       const char* clr, int* dsh,
       int wth, const char* fnt, const char* txt, 
       unsigned short prop, const char* cmt,
       const List<Tag>& tg, const List<CallBack>& cb);

  Marker* dup() {return new Text(*this);}
  void updateBBox();

  void editBegin(int) {}
  void edit(const Vector& v, int h) {}
  void editEnd() {}

  void draw(Drawable, int);
  void drawXOR();
  void drawMagnifier(const Matrix&, int);
  void ps(int mode, int tt);
#ifdef _MACOSX
  void macosx(int);
#endif
#ifdef _WIN32
  void win32(int);
#endif

  void setRotate(int);
  int getRotate() {return rotate;}

  void list(ostream&, CoordSystem, SkyFrame, SkyFormat, int, int);
  void listXML(ostream&, CoordSystem, SkyFrame, SkyFormat);
  void listSAOtng(ostream&, CoordSystem, SkyFrame, SkyFormat, int);
};

#endif
