// Copyright (C) 1999-2009
// Smithsonian Astrophysical Observatory, Cambridge, MA, USA
// For conditions of distribution and use, see copyright notice in "copyright"

#ifndef __gridbase_h__
#define __gridbase_h__

#include <tk.h>

#include "vector.h"

class Widget;

class Attribute {
 public:
  enum Style {SOLID,DASH};
  enum Font {
    DEFAULT=0,TIMES,HELVETICA,SYMBOL,COURIER,
    DEFAULTBOLD=10,TIMESBOLD,HELVETICABOLD,SYMBOLBOLD,COURIERBOLD,
    DEFAULTITALIC=20,TIMESITALIC,HELVETICAITALIC,SYMBOLITALIC,COURIERITALIC
  };
  enum Colour {BLACK,WHITE,RED,GREEN,BLUE,CYAN,MAGENTA,YELLOW};

 private:
  Widget* parent;

  Style style_;
  float width_;

  Font font_;
  int size_;
  Tk_Font tkfont_;

  Colour colour_;
  char* colorName_;
  int color_;

 private:
  void initFont();

 public:
  Attribute(Widget*);
  ~Attribute();

  void setStyle(double);
  void setWidth(double);
  void setSize(double);
  void setFont(double);
  void setColour(double);

  Style style() {return style_;}
  float width() {return width_;}
  int size() {return size_;}
  Font font() {return font_;}
  Colour colour() {return colour_;}

  const char* colorName() {return colorName_;}
  Tk_Font tkfont() {return tkfont_;}
  int color() {return color_;}
};

#endif
